;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;          NTSC2PAL
;      Greg Harder 2020
;================================

@SlowFast=0207
@Display5=02B5
@Display3=0292
@PUSHReg=0220
@POPReg=02A4
@DFile=400C
@Seed=4032

;========================
; Adjust addressing
;========================
	LD HL,(Seed)
	LD BC,002E		;Offset to Vid0
	ADD HL,BC		;HL=vid0 addr
	PUSH HL			;PUSH vid0
	EX DE,HL		;DE=vid0 addr
	LD H,D			;HL=vid0 addr
	LD L,E
	DEC HL			
	DEC HL
	LD (HL),D		;Set 1st LD IX,Vid0
	DEC HL
	LD (HL),E
	LD C,+21		;Offset to 2nd LD IX,Vid0
	ADD HL,BC
	LD (HL),E		;Set 2nd LD IX,Vid0
	INC HL
	LD (HL),D
	POP HL			;POP vid0 addr
	LD C,+11		;Offset to CALL Vid3
	ADD HL,BC		;HL=CALL Vid3
	LD D,H			;DE=CALL Vid3
	LD E,L
	LD C,+12		;Offset to Vid3
	ADD HL,BC		;HL=Vid3 addr
	EX DE,HL		;DE=Vid3 addr,HL=CALL Vid3
	LD (HL),E		;Set CALL Vid3
	INC HL
	LD (HL),D
	LD B,H			;Return Vid0 address to BASIC
	LD C,L
	RET
;==========================
; Video driver
;==========================
@Start
	CALL SlowFast
	LD IX,Vid0 		;1st LD IX
	RET
@Vid0
	LD A,R 
	LD BC,1901 
	LD A,F5
	CALL Display5
	CALL Vid3		;Vid3
	CALL PUSHReg
	LD IX,Vid0		;2nd LD IX
	JP POPReg
@Vid3
	POP IX
	LD A,00			;MARGIN value
	NEG
	EX AF
	OUT FE,A
	POP HL
	POP DE
	POP BC
	POP AF
	RET